
InsecureBlockCipher subclass: #PassthroughBlockCipher
	instanceVariableNames: 'blockSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cryptography-Insecure'!

!PassthroughBlockCipher commentStamp: 'jcg 11/24/2006 02:20' prior: 0!
For when even the XORBlockCipher is too slow.!

!PassthroughBlockCipher methodsFor: 'accessing' stamp: 'jcg 11/24/2006 02:22'!
blockSize
	^ blockSize! !

!PassthroughBlockCipher methodsFor: 'initialize' stamp: 'jcg 11/24/2006 02:21'!
blockSize: sizeInBytes
	blockSize := sizeInBytes.! !

!PassthroughBlockCipher methodsFor: 'accessing' stamp: 'jcg 11/24/2006 02:22'!
decryptBlock: aByteArray
	"do nothing"! !

!PassthroughBlockCipher methodsFor: 'accessing' stamp: 'jcg 11/24/2006 02:22'!
encryptBlock: aByteArray
	"do nothing"! !

!PassthroughBlockCipher methodsFor: 'initialize' stamp: 'jcg 11/24/2006 02:21'!
initialize
	blockSize := 16 "bytes"! !

!PassthroughBlockCipher methodsFor: 'initialize' stamp: 'jcg 11/24/2006 02:22'!
key: ignored
	"We don't need no steeenking key."! !

InsecureBlockCipher subclass: #XORBlockCipher
	instanceVariableNames: 'blockSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cryptography-Insecure'!

!XORBlockCipher commentStamp: '<historical>' prior: 0!
This block cipher simply flips the bits of the plaintext.  This provides no security, but is useful to test the various block cipher modes in a real system that needs high throughput (this cipher will be unnecessary once primitive implementations of real ciphers exist).!

!XORBlockCipher methodsFor: 'accessing' stamp: 'jcg 11/24/2006 01:50'!
blockSize
	^ blockSize! !

!XORBlockCipher methodsFor: 'initialize' stamp: 'jcg 11/24/2006 02:19'!
blockSize: sizeInBytes
	blockSize := sizeInBytes.! !

!XORBlockCipher methodsFor: 'accessing' stamp: 'jcg 11/24/2006 02:01'!
decryptBlock: aByteArray
	self encryptBlock: aByteArray "flip the bits again"
! !

!XORBlockCipher methodsFor: 'accessing' stamp: 'jcg 11/24/2006 02:01'!
encryptBlock: aByteArray
	aByteArray withIndexDo: [:val :ind | aByteArray at: ind put: (val bitXor: 255)]! !

!XORBlockCipher methodsFor: 'initialize' stamp: 'jcg 11/24/2006 02:20'!
initialize
	blockSize := 16 "bytes"! !

!XORBlockCipher methodsFor: 'initialize' stamp: 'jcg 11/24/2006 01:51'!
key: ignored
	"We don't need no steeenking key."! !
SystemOrganization addCategory: #'Cryptography-Insecure'!
